/*
 * lcd_spec_S1D15G10.h
 *
 *  Created on: 2022/03/06
 *      Author: togashitoyohiko
 */

#ifndef LCD_SPEC_S1D15G10_H_
#define LCD_SPEC_S1D15G10_H_

// LCD module native command code
#define LCD_CMD_DISON		0xaf		// Display on                         -
#define LCD_CMD_DISOFF		0xae		// Display off                        -
#define LCD_CMD_DISNOR		0xa6		// Normal display                     -
#define LCD_CMD_DISINV		0xa7		// Inverse display                    -
#define LCD_CMD_COMSCN		0xbb		// Common scan direction              1byte
#define LCD_CMD_DISCTL		0xca		// Display control                    4byte
#define LCD_CMD_SLPIN		0x95		// Sleep in                           -
#define LCD_CMD_SLPOUT		0x94		// Sleep out                          -
#define LCD_CMD_PASET		0x75		// Page address set                   2byte
#define LCD_CMD_CASET		0x15		// Column address set                 2byte
#define LCD_CMD_DATCTL		0xbc		// Data scan direction, etc.          3byte
#define LCD_CMD_RGBSET8		0xce		// 256-color position set             20byte
#define LCD_CMD_RAMWR		0x5c		// Writing to memory                  *
#define LCD_CMD_RAMRD		0x5d		// Reading from memory                *
#define LCD_CMD_PTLIN		0xa8		// Partial display in                 2byte
#define LCD_CMD_PTLOUT		0xa9		// Partial display out                -
#define LCD_CMD_RMWIN		0xe0		// Read and modify write              -
#define LCD_CMD_RMWOUT		0xee		// End                                -
#define LCD_CMD_ASCSET		0xaa		// Area scroll set                    4byte
#define LCD_CMD_SCSTART		0xab		// Scroll start set                   1byte
#define LCD_CMD_OSCON		0xd1		// Internal oscillation on            -
#define LCD_CMD_OSCOFF		0xd2		// Internal oscillation off           -
#define LCD_CMD_PWRCTR		0x20		// Power control                      1byte
#define LCD_CMD_VOLCTR		0x81		// Electronic volume control          2byte
#define LCD_CMD_VOLUP		0xd6		// Increment electronic control by 1  -
#define LCD_CMD_VOLDOWN		0xd7		// Decrement electronic control by 1  -
#define LCD_CMD_TMPGRD		0x82		// Temperature gradient set           14byte


#endif /* LCD_SPEC_S1D15G10_H_ */
