//
//  lcd_spec_SSD1289.h	Solomon Systech LCD Driver SSD1289 command code
//  Copyright(C)2022 Toyohiko Togashi tog001@nifty.com
//
//
//  This program is free software; you can redistribute it and/or modify it under the terms of the
//  GNU General Public License as published by the Free Software Foundation; either version 3
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along with this program.
//  If not, see <http://www.gnu.org/licenses/>
//
//
//   Refernce:
//      Solomon Systech Limited.
//      SEMICONDUCTOR TECHNICAL DATA
//          SSD1289
//          240 RGB x 320 TFT LCD Controller Driver
//              Version      : Rev 1.3
//              Document No. : none
//              Date         : Apr 2007
//
//    Update history
//    ---------- ----- -------------------------------------------
//    2022.03.03 v0.0  First cording
//

#ifndef LCD_SPEC_SSD1289_H_
#define LCD_SPEC_SSD1289_H_

//
// Command code (index value)
//
#define LCD_COMMAND_Oscillator						0x00
#define LCD_COMMAND_DriverOutputControl				0x01
#define LCD_COMMAND_LCDDrivingWaveformControl		0x02
#define LCD_COMMAND_PowerControl1					0x03
#define LCD_COMMAND_CompareRegister1				0x05
#define LCD_COMMAND_CompareRegister2				0x06
#define LCD_COMMAND_DisplayControl					0x07
#define LCD_COMMAND_PowerControl2					0x0c
#define LCD_COMMAND_PowerControl3					0x0d
#define LCD_COMMAND_PowerControl4					0x0e
#define LCD_COMMAND_GateScanPosition				0x0f
#define LCD_COMMAND_SleepMode						0x10
#define LCD_COMMAND_EntryMode						0x11
#define LCD_COMMAND_GenericInterfaceControl			0x15
#define LCD_COMMAND_HorizontalPorch					0x16
#define LCD_COMMAND_VerticalPorch					0x17
#define LCD_COMMAND_PowerControl5					0x1e
#define LCD_COMMAND_WriteDataToGRAM					0x22
#define LCD_COMMAND_ReadDataToGRAM					0x22
#define LCD_COMMAND_RAMwriteDataMask1				0x23
#define LCD_COMMAND_RAMwriteDataMask2				0x24
#define LCD_COMMAND_FrameFrequencyControl	 		0x25
#define LCD_COMMAND_VcomOTP1						0x28
#define LCD_COMMAND_VcomOTP2						0x29
#define LCD_COMMAND_GammaControl 					0x30
#define LCD_COMMAND_GammaControl0 					0x30
#define LCD_COMMAND_GammaControl1 					0x31
#define LCD_COMMAND_GammaControl2 					0x32
#define LCD_COMMAND_GammaControl3 					0x33
#define LCD_COMMAND_GammaControl4 					0x34
#define LCD_COMMAND_GammaControl5 					0x35
#define LCD_COMMAND_GammaControl6 					0x36
#define LCD_COMMAND_GammaControl7 					0x37
#define LCD_COMMAND_GammaControl8 					0x38
#define LCD_COMMAND_GammaControl9 					0x39
#define LCD_COMMAND_GammaControl10 					0x3a
#define LCD_COMMAND_GammaControl11 					0x3b
#define LCD_COMMAND_VerticalScrollControl1	 		0x41
#define LCD_COMMAND_VerticalScrollControl2	 		0x42
#define LCD_COMMAND_HorizontalRAMaddressPosition 	0x44
#define LCD_COMMAND_VerticalRAMaddressPosition1		0x45
#define LCD_COMMAND_VerticalRAMaddressPosition2		0x46
#define LCD_COMMAND_1stScreenDrivingPosition1		0x48
#define LCD_COMMAND_1stScreenDrivingPosition2		0x49
#define LCD_COMMAND_2ndScreenDrivingPosition1		0x4a
#define LCD_COMMAND_2ndScreenDrivingPosition2		0x4b
#define LCD_COMMAND_RAMaddressSetX					0x4e
#define LCD_COMMAND_RAMaddressSetY					0x4f

#endif /* LCD_SPEC_SSD1289_H_ */
