//
//  lcd_spec_XPT2046.h	XPTEK TECHNOLOGY Touch Screen Controller XPT2046 command code
//  Copyright(C)2022 Toyohiko Togashi tog001@nifty.com
//
//
//  This program is free software; you can redistribute it and/or modify it under the terms of the
//  GNU General Public License as published by the Free Software Foundation; either version 3
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along with this program.
//  If not, see <http://www.gnu.org/licenses/>
//
//
//   Reference:
//      SHENZHEN XPTEK TECHNOLOGY CO.,LTD
//      XPT2046 Touch Screen Controller
//          Datasheet
//              Version     : none
//              Document No.: none
//              Date        : 2007.05
//
//    Update history
//    ---------- ----- -------------------------------------------
//    2022.03.13 v0.0  First cording
//

#ifndef LCD_SPEC_XPT2046_H_
#define LCD_SPEC_XPT2046_H_

#define LCD_CB_START		(1 << 7)	//
#define LCD_CB_A(n)			(n << 4)	// 0..7 Channel Select bits
#define LCD_CB_A_Y			LCD_CB_A(0b001)
#define LCD_CB_A_Z1			LCD_CB_A(0b011)
#define LCD_CB_A_Z2			LCD_CB_A(0b100)
#define LCD_CB_A_X			LCD_CB_A(0b101)
#define LCD_CB_MODE_12bit	(0 << 3)	// 12-Bit Conversion Select bit
#define LCD_CB_MODE_8bit	(1 << 3)	// 8-Bit Conversion Select bit
#define LCD_CB_DFR			(0 << 2)	// Differential Reference Select bit
#define LCD_CB_SER			(1 << 2)	// Single-Ended Reference Select bit
#define LCD_CB_PD(n)		(n << 0)	// Power-Down Mode Select bits
#define LCD_CB_PD_AUTO		LCD_CB_PD(0b00)
#define LCD_CB_PD_REF		LCD_CB_PD(0b01)
#define LCD_CB_PD_ADC		LCD_CB_PD(0b10)
#define LCD_CB_PD_NONE		LCD_CB_PD(0b11)

#endif /* LCD_SPEC_XPT2046_H_ */
