//
//  lcd_touch.h		Part of Graphic LCD module I/O library, Touch panel interface
//  Copyright(C)2013-2022 Toyohiko Togashi tog001@nifty.com
//
//
//  This program is free software; you can redistribute it and/or modify it under the terms of the
//  GNU General Public License as published by the Free Software Foundation; either version 3
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along with this program.
//  If not, see <http://www.gnu.org/licenses/>
//
//
//    Update history
//    ---------- ----- -------------------------------------------
//    2013.01.24 v0.0  First cording
//    2014.03.15 v0.2  Rename source file: s95160_t2.h -> lcd_touch.h
//    2022.02.26 v0.2  Delete lcd_touchCalibrate()
//    2022.02.26 v0.2  Add lcd_touchClose()
//    2022.02.26 v0.2  Change lcd_touchOpen() return value
//

#ifndef LCD_TOUCH_H_
#define LCD_TOUCH_H_

//
//	API
//
extern int		lcd_touchOpen(void);					// return < 0 is error
extern short	lcd_touchPoint(short *x, short *y);		// PushRate[%] < 0 is error
extern void		lcd_touchClose(void);					//


#endif /* LCD_TOUCH_H_ */
