//
//  lcd_touch_port_ESP32.c	Part of Graphic LCD module I/O library, Touch screen port I/O
//  Copyright(C)2023 Toyohiko Togashi tog001@nifty.com
//
//
//  This program is free software; you can redistribute it and/or modify it under the terms of the
//  GNU General Public License as published by the Free Software Foundation; either version 3
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along with this program.
//  If not, see <http://www.gnu.org/licenses/>
//
//
//    Host device   : ESP32
//    Library       : esp-idf 5.1
//    IDE tool      : esp-idf 5.1
//
//    Settings
//
//
//    Update history
//    ---------- ----- -------------------------------------------
//    2023.02.26 v0.0  First cording
//

#include <string.h>
#include "lcd_touch_port.h"


//
//	Open
//
void lcd_touchPortStart(void) {
	return;
}

//
// Stop
//
void lcd_touchPortStop(void) {
	return;
}

//
// Now time [ms]
//
uint32_t lcd_touchPortGetTick(void) {
	return(0);
}

//
// Port not define -> dummy routine
//
void	lcd_touchPortSet(enum lcd_touchPortId port, enum lcd_touchPortMode mode, int onOff) {return;}
int	lcd_touchPortGetAnalog(enum lcd_touchPortId port) { return(0); }
size_t	lcd_touchPortSend(size_t len, unsigned char *data) { return(0); }
size_t	lcd_touchPortRecv(size_t len, unsigned char *data) { return(0); }
void	lcd_touchPortCS(int flag) { return; }
