#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <inttypes.h>
#include <unistd.h>
#include "lcd_vcd.h"
#include "driver/gpio.h"

void app_main(void)
{
#if (CONFIG_GPIO_BACKLIGHT >= 0)
    {   // LCD back light ON and init
        gpio_config_t io_conf = {
            .pin_bit_mask = (1ULL << CONFIG_GPIO_BACKLIGHT ),
            .mode         = GPIO_MODE_OUTPUT,
            .pull_up_en   = GPIO_PULLUP_DISABLE,
            .pull_down_en = GPIO_FLOATING,
            .intr_type    = GPIO_INTR_DISABLE,
        };
        
        ESP_ERROR_CHECK(gpio_config(&io_conf));
        ESP_ERROR_CHECK(gpio_set_level(CONFIG_GPIO_BACKLIGHT, 1));
    }
#endif


    lcd_control(LCD_CURSOR_OFF);
    lcd_color(LCD_COLOR_CYAN);

    lcd_position(1, 3);
    lcd_print("Graphic LCD Library");

    lcd_color(LCD_COLOR_YELLOW);
    lcd_position(5, 5);
    lcd_print("ATM0177B2A");
    lcd_position(3, 6);
    lcd_print("Espressif ESP32");

    lcd_color(LCD_COLOR_WHITE);
    lcd_position(0, 8);
    lcd_print("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
    lcd_position(0, 10);
    lcd_print("abcdefghijklmnopqrstuvwxyz");
    lcd_position(0, 12);
    lcd_print("0123456789");
    lcd_position(0, 13);
    lcd_print("~!@#$%%^&*()_+-=[]{}|\\;:'\",./<>?");
}

